//-, =AVR,  7=, i, 7, 2005 =1
//Make: Name=avr71, MCU=atmega8, Level=2, Debug=VMLab     =2
//: BODEN=BODLEVEL=SUT0=CKSEL3=CKSEL2=CKSEL1="0" 1=3
#include <avr/io.h>             // - =4
#include <avr/eeprom.h>      //   EEPROM =5
#include <stdlib.h>       //   =6
#define E unsigned __attribute__ ((section(".eeprom"))) //=7
#define RS PC0        //    RS () =8
#define EN PC2         //    E () =9
#define SB PB2  //     SB1 () =10
#define TIME 10     //    1  =11
static E char t0[]="=-== -7/05="; //=12
static E char t1[]=" .      "; //=13
static E char t2[]="            "; //=14
static E char t3[]="  -   .  "; //=15
static E char t4[]="     !!!  ? "; //=16
//---------------  --------------- =17
void pause(unsigned int a)    //"a" -   =18
{ unsigned int cn;              //"cn" -   =19
  for (cn=a; cn > 0; cn--);      //   =20
}                            //  "pause" =21
//-----------    --------------- =22
void lcd_com(unsigned char p)       //"p" -   =23
{ PORTC &= ~_BV(RS);                       // RS=0 =24
  PORTC |= _BV(EN);                        // EN=1 =25
  PORTD &= 0x0F; PORTD |= (p & 0xF0);    //  =26
  pause(TIME);                 //  EN =27
  PORTC &= ~_BV(EN);   //EN=0,      =28
  pause(TIME);                 //  EN =29
  PORTC |= _BV(EN);                        // EN=1 =30
  PORTD &= 0x0F; PORTD |= (p << 4);      //  =31
  pause(TIME);                 //  EN =32
  PORTC &= ~_BV(EN);   //EN=0,      =33
  pause(5*TIME);          //    =34
}                          //  "lcd_com" =35
//-----------    ---------------- =36
void lcd_dat(unsigned char p)        //"p" -   =37
{ PORTC |= _BV(RS) | _BV(EN);       // RS=1, EN=1 =38
  PORTD &= 0x0F; PORTD |= (p & 0xF0);    //  =39
  pause(TIME);                 //  EN =40
  PORTC &= ~_BV(EN);   //EN=0,      =41
  pause(TIME);                 //  EN =42
  PORTC |= _BV(EN);                        // EN=1 =43
  PORTD &= 0x0F; PORTD |= (p << 4);      //  =44
  pause(TIME);                 //  EN =45
  PORTC &= ~_BV(EN);   //EN=0,      =46
  pause(5*TIME);          //    =47
}                          //  "lcd_dat" =48
//------------  ----------------- =49
void lcd_init(void)       // 4 ,   =50
{ lcd_com(0x33); pause(500*TIME);           // =51
  lcd_com(0x32); lcd_com(0x28);        //4 , 2  =52
		lcd_com(0x08);             //   =53
		lcd_com(0x01); pause(1000*TIME);     //  =54
  lcd_com(0x06);                  //   =55
  lcd_com(0x0D);    // ,   =56
}                         //  "lcd_init" =57
//================ ==================== =58
int main(void)               //   =59
{ unsigned char a, b, c;                      // =60
  unsigned int d=0, e=0;    //   =61
  PORTB = DDRD = 0xFF; //=  , D= =62
  PORTC = 0xF8; DDRC = 0x07;    //PC0...2   .0 =63
  lcd_init();          //  (4 , 162) =64
  while (1)                           //  =65
		{	for (b=0; b<5; b++)   //     =66
		  { for (lcd_com(0x80), a=0; a<32; a++) // =67
      { if (a==16) lcd_com(0xC0);        //  =68
        if (b==0) lcd_dat(eeprom_read_byte(&t0[a])); //1 =69
								if (b==1) lcd_dat(eeprom_read_byte(&t1[a])); //2 =70
								if (b==2) lcd_dat(eeprom_read_byte(&t2[a])); //3 =71
								if (b==3) lcd_dat(eeprom_read_byte(&t3[a])); //4 =72
								if (b==4) lcd_dat(eeprom_read_byte(&t4[a])); //5 =73
						}  //    2   16  =74
		    if ((b==1) || (b==2)) //    2  3 =75
						{ lcd_com(0xCE); lcd_dat(d + 0x30); //., =76
						}     //      =77
						if (b==2)      //     3 =78
						{ c=d * e; lcd_com(0x8C);      //  =79
        lcd_dat(c/10 + 0x30); lcd_dat(c%10 + 0x30);    //=80
						}             //    =81
						if (b==4)     //     5 =82
						{ lcd_com(0xC1); lcd_dat(e + 0x30); //,  =83
						}            //    =84
						while(bit_is_set(PINB,SB))  //   =85
      { if (b==0)  //    =86
						  { d=rand()%8 + 2; e=rand()%9 + 1; //d=2-9, e=1-9 =87
								}          //    =88
				  }         //    SB1 =89
      pause(65000); pause(65000);   //  =90
				}                 //      =91
		}                //     =92
} //WinAVR-20050214, FLASH 1240 , EEPROM 165 =93
