// "lcd.c",   . = 7=, -7/2005 =1
// 4-   PD4...PD7, WinAVR-20050214   =2
#include <avr/io.h>            // -  =3
#define RS PC0        //    RS () =4
#define EN PC2         //    E () =5
#define TIME 10               //     =6
//---------------  ---------------  =7
void pause(unsigned int p)    //"p" -    =8
{ unsigned int cn;              //"cn" -    =9
  for (cn=p; cn > 0; cn--);      //   =10
}                            //  "pause" =11
//-------   lcd_com, lcd_dat----------- =12
void lcd(unsigned char p) //"p" -     =13
{ PORTD &= 0x0F; PORTD |= (p & 0xF0);    //  =14
  pause(TIME);                 //  EN =15
  PORTC &= ~_BV(EN);   //EN=0,      =16
  pause(TIME);                 //  EN =17
  PORTC |= _BV(EN);                        // EN=1 =18
  PORTD &= 0x0F; PORTD |= (p << 4);      //  =19
  pause(TIME);                 //  EN =20
  PORTC &= ~_BV(EN);   //EN=0,      =21
  pause(5*TIME);          //    =22
}                              //  "lcd" =23
//-----------    --------------- =24
void lcd_com(unsigned char p)       //"p" -   =25
{ PORTC &= ~_BV(RS); PORTC |= _BV(EN);      //RS=0, EN=1 =26
  lcd(p);   //    lcd_com, lcd_dat =27  
}                          //  "lcd_com" =28
//-----------    ---------------- =29
void lcd_dat(unsigned char p)        //"p" -   =30
{ PORTC |= _BV(RS) | _BV(EN);               //RS=1, EN=1 =31
  lcd(p);   //    lcd_com, lcd_dat =32  
}                          //  "lcd_dat" =33
//------------  ----------------- =34
void lcd_init(void)       // 4 ,   =35
{ lcd_com(0x33); pause(500*TIME);           // =36
  lcd_com(0x32); lcd_com(0x28);        //4 , 2  =37
		lcd_com(0x08);             //   =38
		lcd_com(0x01); pause(1000*TIME);     //  =39
  lcd_com(0x06);                  //   =40
  lcd_com(0x0D);    // ,   =41
}                         //  "lcd_init" =42
